<?php
include(ROOT."/Image.php");

class ProfilController extends Controller { // classe de contrôleur pour l'affichage des profils
	public function display() {
		$slug = $this->route["params"]["slug"]; // on récupère le "slug", en gros tout le reste de l'URL qui n'a pas encore servi
		// je précise que dans ce cas précis, le $slug ne contient que le pseudo du joueur sosu forme normalisée. Donc je pourrais renommer la variable $slug_joueur...
		$this->view->profil = Profil::getFromSlug($slug); // on utilise le modèle pour aller chercher en BDD le profil qui nous intéresse
	 	$this->view->profil->avatar = $this->view->profil->avatar ? BASE_URL."/images/avatar/".$this->view->profil->slug.".jpg": BASE_URL."/images/profil_42.jpg";
		list($i, $o, $p) = Classement::getClassementJoueur($slug);
		$this->view->classement_top = $i;
		$this->view->classement_down = $o;
		$this->view->jeu_favori = $p;
		$this->view->display(); // on affiche ce profil
	}

	public function displayEdit() {
		$slug = $this->route["params"]["slug"]; // on récupère le "slug", en gros tout le reste de l'URL qui n'a pas encore servi
		// je précise que dans ce cas précis, le $slug ne contient que le pseudo du joueur sosu forme normalisée. Donc je pourrais renommer la variable $slug_joueur...
		$this->view->profil = Profil::getFromSlug($slug); // on utilise le modèle pour aller chercher en BDD le profil qui nous intéresse
		
		session_start();
		
		
		if(isset($_SESSION['registerErrCode'])) { // si message d'erreur
			$errCode = $_SESSION['registerErrCode'];
			if($errCode == 2) { // on détermine le message
				$errMsg = '<h3>Pseudo déjà utilisé !</h3>';
			} 
			elseif($errCode == 3) {
				$errMsg = '<h3>Adresse e-mail déjà utilisée !</h3>';
			} 
			elseif($errCode == 4) {
				$errMsg = '<h3>Mots de passe différents</h3>';
			} 
			elseif($errCode == 5) {
				$errMsg = '<h3>Problème sur l\'avatar</h3>';
			} 
			elseif($errCode == 6) {
				$errMsg = '<h3>Le fichier n\'est pas une image</h3>';
			} 
			elseif($errCode == 7) {
				$errMsg = '<h3>L\'image est trop grande</h3>';
			}
            else{
                $errMsg = "<h3>Exception non gérée.</h3>";
            }
			
			unset($_SESSION['registerErrCode']); // on retire la variable de session
			
            $this->view->errMsg = $errMsg;
		}
		
		$this->view->display(); // on affiche ce profil
	}

	public function displayValid() {
		$slug = $this->route["params"]["slug"]; // on récupère le "slug", en gros tout le reste de l'URL qui n'a pas encore servi
		// je précise que dans ce cas précis, le $slug ne contient que le pseudo du joueur sosu forme normalisée. Donc je pourrais renommer la variable $slug_joueur...
		$this->view->profil = Profil::getFromSlug($slug); // on utilise le modèle pour aller chercher en BDD le profil qui nous intéresse
		$this->view->display(); // on affiche ce profil
	}
	
	public function verifyEdit() {
		if (!isset($_POST['nom']) || !isset($_POST['prenom']) || !isset($_POST['email'])) { // si l'une des données manque, erreur
			echo "<h1>Erreur : variables absentes</h1>";
			die();
		}
		$slug = $this->route["params"]["slug"];
		$profil = Profil::getFromSlug($slug);
		if (isset($_POST['password']) && isset($_POST['password_bis']) && $_POST['password'] != "") {
			if ($_POST['password'] == $_POST['password_bis']) {
				$password = password_hash($_POST['password'], PASSWORD_DEFAULT);
				Profil::setPassword($slug, $password);
			} else {
				session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
				$_SESSION["registerErrCode"] = 4; // on stocke le code d'erreur
				header('Location:../edit'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne)
				die();
			}
		}
		$data = $_POST;
		if(!isset($data['avatar_suppr'])) {
			if(isset($_FILES['avatar'])) {
				list($err, $avatar) = getImage($_FILES['avatar'], 512, 512);
				if ($err == 0) {
					unlink(ROOT . "/www/images/avatar/" . $slug . ".jpg");
					saveImage($avatar, ROOT . "/www/images/avatar/" . $slug . ".jpg");
					$data['avatar'] = 1;
				} elseif ($err == 1) {
					$data['avatar'] = $profil->avatar;
				} else {
					session_start(); // on démarre une session pour avoir accès aux variables superglobales de session
					$_SESSION["registerErrCode"] = $err; // on stocke le code d'erreur
					header('Location:../edit'); // on redirige vers la page de formulaire (il faut faire un retour dans le dossier parent pour que ça fonctionne)
					die();
				}
			} else {
				$data['avatar'] = $profil->avatar;
			}
		} else {
			unlink(ROOT."/www/images/avatar/".$slug.".jpg");
			$data['avatar'] = 0;
		}
		Profil::setAutre($slug, $data);
		session_start();
		$_SESSION['user'] = Connexion::getUser($slug);
		header('Location:valid');
	}
}
